function [theta_grid,K,iter_time,theta_ori,STEP,grid_number,Error] = Acceleration_RLS(y,theta_0,Tau,alpha,poles,P_noise)
% MMSE_narrowband
grid_num =length(theta_0);
theta_grid=theta_0;
f_temp=sind(theta_grid);                                                           
iter_max=500;
smp=1:size(y,1);
L=size(y,2);
epsilon=1e-3;
k=0;
iter=0;
theta_ori=zeros(grid_num,iter_max);
grid_unchange=0;
grid_unchange_old=0;
grid_conv=0;
grad_change=zeros(10,iter_max);
Amp=zeros(grid_num,iter_max);
STEP=zeros(grid_num,iter_max);
FLAG=zeros(grid_num,iter_max);
flag_acc=0;
grid_number=zeros(iter_max,1);
Grad=zeros(grid_num,iter_max);
Theta_temp=zeros(grid_num,iter_max);
Error=zeros(1,iter_max);
%    figure;
%     stem(theta_grid,x_newplot,'b','LineWidth',1);                     
%     stem(theta_grid, ones(6,1).*diag(1./Tau),'b','LineWidth',1);  
%     hold on
%     stem(asind(poles),ones(length(poles),1),'r^','LineWidth',2);
%     legend('estimated','true')
% %     title('Uncut')
%     xlabel('\theta grid');
%     ylabel('Estimated power');
%     xlabel('\fontname{Simsun}Ƕ/\circ')
% ylabel('\fontname{Simsun}һĹ')
% legend('\fontname{Simsun}ֵ','\fontname{Simsun}ʵֵ');
% xlim([-90,90]);
% set(gca,'FontSize',20);
% grid on
% box on
%     xlim([-90,90]);
%     set(gca,'Fontsize',20)
%     grid on
for iter=1:iter_max
    iter
    theta_ori(1:length(theta_grid),iter)=theta_grid;
    grid_number(iter)=length(f_temp);
    %% Construct Dictionary
    if size(f_temp,2)<size(f_temp,1)
        f_temp=f_temp';
    end
    A=exp(-1j*pi*(smp-1)'.*f_temp);                    %Dictionary
    if iter==1
        X=zeros(size(A,2),size(y,2));
    end
    Error(iter)=norm(y-A*X,'fro');
    %% Estimate X and X_i
    if size(A,2)~=size(Tau,1)
        disp('Wrong')
    end
    X=inv(A'*A+Tau)*A'*y;                                    %Tau??
    x_newplot=[];
    for i=1:size(X,1)
        x_newplot(i)=norm(X(i,:));                           %X_i
    end
    P_est=diag(x_newplot'*x_newplot/L);               %P_est
    P_est=P_est./max(P_est);
    %% Pruning X_i
    
    index=[];
    k=0;
    

    for ii=1:length(P_est)
        if  P_est(ii)<P_noise          %
            X(ii,:)=0;
            f_temp(ii)=0;
            theta_grid(ii)=0;
            x_newplot(ii)=0;
            P_est(ii)=0;
            k=k+1;
            index(k)=ii;
        end
    end
    
    theta_grid(index)=[];
    X(all(X==0,2),:) = [];
    P_est(index)=[];
    f_temp(index)=[];
    x_newplot=nonzeros(x_newplot);
    Tau=diag(1./P_est);
    
    %% Update theta
    grad=zeros(size(X,1),1);
    grad_acc=zeros(size(X,1),1);
    flag=zeros(length(grad),1);
    clear theta_temp
    
    if size(f_temp,2)<size(f_temp,1)
        f_temp=f_temp';
    end
    A=exp(-1j*pi*(smp-1)'*f_temp);
    old_res=trace((y-A*X)'*(y-A*X));
    for g=1:length(grad)
        grad_flag=0;
        A_temp=zeros(size(A));
        theta_temp=zeros(size(theta_grid));
        theta_temp=theta_grid;
        B=zeros(length(smp),length(f_temp));
        B(:,g)=-1j*pi*(smp-1)'.*cosd(theta_temp(g));
        A_temp=A;
        grad(g)=2*real(trace(((A*X)'-y')*(B.*A_temp)*X));         %
        theta_nonacc=theta_grid;
        
                while abs(grad(g))>10
            grad(g)=grad(g)/10;
            grad_flag=grad_flag+1;
        end
        
        if (grid_conv==1)&&(sign(grad_old(g))==sign(grad(g)))&&(length(grad_old)==length(grad))
            flag_acc=1;
        else flag_acc=0;
        end
        
        if (grid_unchange==1)&&(flag_acc==1)
            step=1/10.^(flag_old(g));
            theta_temp(g)=theta_grid(g)-alpha*step*grad_old(g);     % 
            theta_grid(g)=theta_temp(g);
            A_temp_acc=zeros(size(A));
            theta_temp_acc=zeros(size(theta_grid));
            theta_temp_acc=theta_grid;
            B_acc=zeros(length(smp),length(f_temp));
            B_acc(:,g)=-1j*pi*(smp-1)'.*cosd(theta_temp_acc(g));
            A_temp_acc=A;
            grad_acc(g)=2*real(trace(((A*X)'-y')*(B_acc.*A_temp_acc)*X));         %
            if sign(grad_acc(g))==sign(grad(g))
                while abs(grad_acc(g))>10
                    grad_acc(g)=grad_acc(g)/10;
                end
                disp('acc');
                grad(g)=grad_acc(g);
            else theta_grid(g)=theta_nonacc(g);
            end
        end
        
      
        A_new=A;
        step=1;
        theta_temp(g)=theta_grid(g)-step*grad(g);
        A_new(:,g)=exp(-1j*pi*(smp-1)'.*sind(theta_temp(g)));
        new_res=trace((y-A_new*X)'*(y-A_new*X));
        while (old_res-new_res<0) | (old_res-new_res==0) && flag(g)<=10
            step=1/10*step;
            theta_temp(g)=theta_grid(g)-step*grad(g);
            A_new(:,g)=exp(-1j*pi*(smp-1)'.*sind(theta_temp(g)));
            new_res=trace((y-A_new*X)'*(y-A_new*X));
            flag(g)=flag(g)+1;
        end
        
        theta(g)=theta_temp(g);
        f_temp(g)=sind(theta(g));
        Grad(g,iter)=grad(g);
        STEP(g,iter)=step;
        Theta_temp(g,iter)=theta_temp(g);
        clear A_new
    end
    
    clear g
    [theta,ind]=sort(theta,'ascend');
    theta_grid=theta;
    
    
    xnew=zeros(size(X));
    for i=1:length(ind)
        xnew(i,:)=X(ind(i),:);
    end
    X=xnew;
    x_newplot=zeros(size(X,1),1);
    for ix=1:size(X,2)
        x_newplot=x_newplot+abs(X(:,ix));
    end
    
    x_newplot=x_newplot/L;
    f_temp=sind(theta_grid);
    
    
    if size(f_temp,2)<size(f_temp,1)
        f_temp=f_temp';
    end
    A_new=exp(-1j*pi*(smp-1)'.*f_temp);
    A=A_new;
%     theta_ori(1:length(theta_grid),iter)=theta_grid;
    

    f_temp=sort(f_temp,'ascend');
    if iter>2
        stop_flag=0;       %
        if length(f_temp_old)==length(f_temp)
            x_newplot_temp=x_newplot./max(x_newplot);
            x_newplotold-x_newplot_temp;
            grid_unchange=1;
            for f=1:length(f_temp)
                if abs(theta_grid_old(f)-theta_grid(f))<1e-3
                    stop_flag= stop_flag+1;
                end
            end
            stop_flag
        else grid_unchange=0;      %
        end
        if  stop_flag==length(f_temp)        %
            K=length(f_temp);
            iter_time=iter;
            break;
        end
    end
    
    if  grid_unchange==1  %
        grid_conv=1;
        grad_old=grad;       %
        flag_old=flag;
        grad_change(1:length(grad),iter)=grad;
        grad_change(length(grad)+1:length(grad)+length(flag),iter)=flag;
    end
    f_temp_old=f_temp;
    theta_grid_old=theta_grid;
    clear ind
    clear theta
    grid_unchange_old=grid_unchange;
    
    
    if max(x_newplot)>1 | flag_acc==1
        x_newplot=x_newplot./max(x_newplot);
    end
    x_newplotold=x_newplot;
end
grid_number=nonzeros(grid_number);
if iter==iter_max
    clear f_temp K iter_time
    theta_grid= theta_grid;
    error=theta_grid'-asind(poles);
    K=length(theta_grid);
    iter_time=iter_max;
end

end


