function [group,P_est,fBlock,fBlockplot]=wideband_Estmation(B,y,poles,range,lambda)
L=size(y,2);
M=size(y,1);
t = (1:M-1)';
fBlock=zeros(1,B+1+1);
fBlock(1:end-1) = linspace(range(1),range(end),B+1);
fBlock(end)=fBlock(end-1)+M;
bandWidth=fBlock(2)-fBlock(1);
A1 = zeros(M,B);
A1(1,:)=1;

A_noise=ones(M,1);
A_noise=A_noise/norm(A_noise);

for iM=1:B
    a = 1./(-1i*pi*t).*(exp(-1i*pi*t*sind(fBlock(iM+1)))-...   %Wideband Dictionary
        exp(-1i*pi*t*sind(fBlock(iM))));
    A1(2:end,iM)=a/norm(a);
end

A_1=[A1,A_noise];      %SPICE_like dictionary

Tau=diag(ones(size(A_1,2),1));
X=inv(A_1'*A_1+Tau)*A_1'*y;


X_est=[];
for i=1:size(X,1)
    X_est(i)=norm(X(i,:));             %X_i
end
clear i;
P_est=diag(X_est'*X_est/L);       %P_est
P_est=P_est./max(P_est);
fBlockplot=zeros(length(P_est),1);
fBlockplot(1:end-1)=fBlock(1:length(P_est)-1)+ones(1,length(P_est)-1)*bandWidth/2; 
fBlockplot(end)=(fBlock(end)+fBlock(end-1))/2;
figure;
bar(fBlockplot,P_est',1,'b');
hold on
stem(asind(poles),ones(length(poles),1)*max(P_est),'r^','LineWidth',2);
yline(P_est(end),'r:','LineWidth',2);
xlim([-90,90+M]);
xticks([-81 -63,-45,-27,-9,9,27,45,63,81,110])
% xticklabels({'B_1','B_2','B_3','B_4','B_5','B_6','B_7','B_8','B_9','B_{10}',''})
% legend('\fontname{Simsun}ֵ','\fontname{Simsun}ʵֵ','\fontname{Simsun}ضֵ');
% set(gca,'FontSize',20);
% grid on
% box on
xlabel('\theta grid')
ylabel('Estimated power')
xlim([-90,90+M]);
legend('estimated','true','noise power');
set(gca,'FontSize',20);
grid on
box on

%% Pruning part
group=[];
g_flag=1;

for ii=1:length(P_est)-1
    if P_est(ii)>P_est(end)                   %Pruning
        group( g_flag)=ii;
        g_flag= g_flag+1;
    else P_est(ii)=-1;
    end
end

P_temp=P_est;
% fBlockplot(P_est==-1)=[];

P_est(P_est==-1)=[];

end
